# \QueryAbstract_Query_Builder

Abstract Class for internal implementation methods of the Query Builder

## Summary

Methods
Properties
Constants
No public methods found
$conn_name
$queries
$db
KEY
VALUE
BOTH
_mixed_set()
_select()
_get_compile()
_like()
_having()
_where()
_where_string()
_where_in()
_run()
_append_map()
_append_query()
_compile_type()
_compile()
$select_string
$from_string
$set_string
$order_string
$group_string
$set_array_keys
$order_array
$group_array
$values
$where_values
$limit
$offset
$query_map
$having_map
$explain
$parser
$util
$sql
N/A
No private methods found
No private properties found
N/A
abstract

File
  src/Query/Abstract_Query_Builder.php
Package
  Query
Class hierarchy
  \Query\Abstract_Query_Builder

## Tags

None found

## Constants

### KEY

    KEY

#

## Tags

None found

### VALUE

    VALUE

#

## Tags

None found

### BOTH

    BOTH

#

## Tags

None found

## Properties

### $conn_name

    $conn_name : string

Convenience property for connection management

#### Type

string

#

## Tags

None found

### $queries

    $queries : array

List of queries executed

#### Type

array

#

## Tags

None found

### $db

    $db : \Query\Driver_Interface

The current database driver

#### Type

\Query\Driver_Interface

#

## Tags

None found

### $select_string

    $select_string : string

Compiled 'select' clause

#### Type

string

#

## Tags

None found

### $from_string

    $from_string : string

Compiled 'from' clause

#### Type

string

#

## Tags

None found

### $set_string

    $set_string : string

Compiled arguments for insert / update

#### Type

string

#

## Tags

None found

### $order_string

    $order_string : string

Order by clause

#### Type

string

#

## Tags

None found

### $group_string

    $group_string : string

Group by clause

#### Type

string

#

## Tags

None found

### $set_array_keys

    $set_array_keys : array

Keys for insert/update statement

#### Type

array

#

## Tags

None found

### $order_array

    $order_array : array

Key/val pairs for order by clause

#### Type

array

#

## Tags

None found

### $group_array

    $group_array : array

Key/val pairs for group by clause

#### Type

array

#

## Tags

None found

### $values

    $values : array

Values to apply to prepared statements

#### Type

array

#

## Tags

None found

### $where_values

    $where_values : array

Values to apply to where clauses in prepared statements

#### Type

array

#

## Tags

None found

### $limit

    $limit : string

Value for limit string

#### Type

string

#

## Tags

None found

### $offset

    $offset : integer

Value for offset in limit string

#### Type

integer

#

## Tags

None found

### $query_map

    $query_map : array

Query component order mapping for complex select queries

Format: array( 'type' => 'where', 'conjunction' => ' AND ', 'string' => 'k=?' )

#### Type

array

#

## Tags

None found

### $having_map

    $having_map : array

Map for having clause

#### Type

array

#

## Tags

None found

### $explain

    $explain : boolean

Whether to do only an explain on the query

#### Type

boolean

#

## Tags

None found

### $parser

    $parser : \Query\Query_Parser

Query parser class instance

#### Type

\Query\Query_Parser

#

## Tags

None found

### $util

    $util : \Query\Driver\Abstract_Util

Alias to driver util class

#### Type

\Query\Driver\Abstract_Util

#

## Tags

None found

### $sql

    $sql : \Query\Driver\SQL_Interface

Alias to driver sql class

#### Type

\Query\Driver\SQL_Interface

#

## Tags

None found

## Methods

### _mixed_set()

    _mixed_set(array  $var, mixed  $key, mixed  $val = NULL, integer  $val_type = self::BOTH) : array

Set values in the class, with either an array or key value pair

#### Parameters

array | $var |
mixed | $key |
mixed | $val |
integer | $val_type |

#### Returns

array

#

## Tags

None found

### _select()

    _select(string  $field, string|boolean  $as = FALSE) : string

Method to simplify select_ methods

#### Parameters

string | $field |
string|boolean | $as |

#### Returns

string

#

## Tags

None found

### _get_compile()

    _get_compile(string  $type, string  $table, boolean  $reset) : string

Helper function for returning sql strings

#### Parameters

string | $type |
string | $table |
boolean | $reset |

#### Returns

string

#

## Tags

None found

### _like()

    _like(string  $field, mixed  $val, string  $pos, string  $like = 'LIKE', string  $conj = 'AND') : \Query\Query_Builder

Simplify 'like' methods

#### Parameters

string | $field |
mixed | $val |
string | $pos |
string | $like |
string | $conj |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### _having()

    _having(mixed  $key, mixed  $val = array(), string  $conj = 'AND') : \Query\Query_Builder

Simplify building having clauses

#### Parameters

mixed | $key |
mixed | $val |
string | $conj |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### _where()

    _where(mixed  $key, mixed  $val = array()) : array

Do all the repeditive stuff for where/having type methods

#### Parameters

mixed | $key |
mixed | $val |

#### Returns

array

#

## Tags

None found

### _where_string()

    _where_string(mixed  $key, mixed  $val = array(), string  $defaultConj = 'AND') : \Query\Query_Builder

Simplify generating where string

#### Parameters

mixed | $key |
mixed | $val |
string | $defaultConj |

#### Returns

\Query\Query_Builder

#

## Tags

None found

### _where_in()

    _where_in(mixed  $key, mixed  $val = array(), string  $in = 'IN', string  $conj = 'AND') : \Query\Query_Builder

Simplify where_in methods

#### Parameters

mixed | $key |
mixed | $val |

string

$in

- The (not) in fragment

string

$conj

- The where in conjunction

#### Returns

\Query\Query_Builder

#

## Tags

None found

### _run()

    _run(string  $type, string  $table, string  $sql = NULL, array|null  $vals = NULL) : \PDOStatement

Executes the compiled query

#### Parameters

string | $type |
string | $table |
string | $sql |
array|null | $vals |

#### Returns

\PDOStatement

#

## Tags

None found

### _append_map()

    _append_map(string  $conjunction = '', string  $string = '', string  $type = '') : void

Add an additional set of mapping pairs to a internal map

#### Parameters

string | $conjunction |
string | $string |
string | $type |

#

## Tags

None found

### _append_query()

    _append_query(array  $vals, string  $sql, string  $total_time) : void

Convert the prepared statement into readable sql

#### Parameters

array | $vals |
string | $sql |
string | $total_time |

#

## Tags

None found

### _compile_type()

    _compile_type(string  $type = '', string  $table = '') : string

Sub-method for generating sql strings

#### Parameters

string | $type |
string | $table |

#### Returns

string

#

## Tags

None found

### _compile()

    _compile(string  $type = '', string  $table = '') : string

String together the sql statements for sending to the db

#### Parameters

string | $type |
string | $table |

#### Returns

string

#

## Tags

None found

### Abstract_Query_Builder.php